"use strict";

var _vue = _interopRequireDefault(require("vue"));

var _expect = _interopRequireDefault(require("expect"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n      background: ", ";\n    "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n      color: blue;\n    "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n      color: blue;\n    "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var styled;
describe('"as" polymorphic prop', function () {
  beforeEach(function () {
    styled = (0, _utils.resetStyled)();
  });
  it('should render "as" polymorphic prop element', function () {
    var Base = styled.div(_templateObject());
    var b = new _vue["default"]({
      render: function render(h) {
        return h(Base, {
          props: {
            as: 'button'
          }
        });
      }
    }).$mount();
    (0, _expect["default"])(b.$el.tagName.toLowerCase()).toEqual('button');
  });
  it('should append base class to new components composing lower level styled components', function () {
    var Base = styled.div(_templateObject2());
    var Composed = styled(Base, {
      bg: String
    })(_templateObject3(), function (props) {
      return props.bg;
    });
    var b = new _vue["default"](Base).$mount();
    var c = new _vue["default"]({
      render: function render(h) {
        return h(Composed, {
          props: {
            bg: 'yellow',
            as: 'dialog'
          }
        });
      }
    }).$mount();
    (0, _expect["default"])(c.$el.tagName.toLowerCase()).toEqual('dialog');
    (0, _expect["default"])(c.$el._prevClass.includes(b.$el._prevClass)).toBeTruthy();
    (0, _utils.expectCSSMatches)('.a{color: blue;} .b{background:yellow;}');
  });
});